Module org.jfree.chart3d
Package org.jfree.chart3d.data

# Interface KeyedValues3D<S extends Comparable<S>,R extends Comparable<R>,C extends Comparable<C>,T>

Type Parameters:
  `S` - The series key type.
  `R` - The row key type.
  `C` - The column key type.
  `T` - The value type.

All Superinterfaces:
  `Values3D<T>`

All Known Subinterfaces:
  `CategoryDataset3D<S,R,C>`

All Known Implementing Classes:
  `DefaultKeyedValues3D`, `StandardCategoryDataset3D`

public interface KeyedValues3D<S extends Comparable<S>,R extends Comparable<R>,C extends Comparable<C>,T> extends Values3D<T>
A three dimensional cube of data values where each value is uniquely identified by three keys (the `seriesKey`, `rowKey` and `columnKey`).

## Method Summary

Modifier and Type
Method
Description
`int`
`getColumnIndex(C columnkey)`
Returns the index of the specified column key, or `-1` if there is no matching key.
`C`
`getColumnKey(int columnIndex)`
Returns the column key with the specified index.
`List<C>`
`getColumnKeys()`
Returns a list of the column keys for the dataset.
`int`
`getRowIndex(R rowkey)`
Returns the index of the specified row key, or `-1` if there is no matching key.
`R`
`getRowKey(int rowIndex)`
Returns the row key with the specified index.
`List<R>`
`getRowKeys()`
Returns a list of the row keys for the dataset.
`int`
`getSeriesIndex(S serieskey)`
Returns the index of the specified series key, or `-1` if there is no matching key.
`S`
`getSeriesKey(int seriesIndex)`
Returns the series key with the specified index.
`List<S>`
`getSeriesKeys()`
Returns a list of the series keys for the dataset.
`T`
`getValue(S seriesKey, R rowKey, C columnKey)`
Returns the value for a given series, row and column.

### Methods inherited from interface org.jfree.chart3d.data.Values3D

`getColumnCount, getDoubleValue, getRowCount, getSeriesCount, getValue`

## Method Details

### getSeriesKeys

List<S> getSeriesKeys()
Returns a list of the series keys for the dataset. Modifying this list will have no impact on the underlying dataset.

Returns:
  A list of the series keys (possibly empty, but never `null`).

### getRowKeys

List<R> getRowKeys()
Returns a list of the row keys for the dataset. Modifying this list will have no impact on the underlying dataset.

Returns:
  A list of the row keys (possibly empty, but never `null`).

### getColumnKeys

List<C> getColumnKeys()
Returns a list of the column keys for the dataset. Modifying this list will have no impact on the underlying dataset.

Returns:
  A list of the column keys (possibly empty, but never `null`).

### getSeriesKey

S getSeriesKey(int seriesIndex)
Returns the series key with the specified index.

Parameters:
  `seriesIndex` - the series index.
Returns:
  The key.

### getRowKey

R getRowKey(int rowIndex)
Returns the row key with the specified index.

Parameters:
  `rowIndex` - the row index.
Returns:
  The key.

### getColumnKey

C getColumnKey(int columnIndex)
Returns the column key with the specified index.

Parameters:
  `columnIndex` - the column index.
Returns:
  The key.

### getSeriesIndex

int getSeriesIndex(S serieskey)
Returns the index of the specified series key, or `-1` if there is no matching key.

Parameters:
  `serieskey` - the series key (`null` not permitted).
Returns:
  The key index, or `-1`.

### getRowIndex

int getRowIndex(R rowkey)
Returns the index of the specified row key, or `-1` if there is no matching key.

Parameters:
  `rowkey` - the row key (`null` not permitted).
Returns:
  The row index or `-1`.

### getColumnIndex

int getColumnIndex(C columnkey)
Returns the index of the specified column key, or `-1` if there is no matching key.

Parameters:
  `columnkey` - the column key (`null` not permitted).
Returns:
  The column index or `-1`.

### getValue

T getValue(S seriesKey, R rowKey, C columnKey)
Returns the value for a given series, row and column.

Parameters:
  `seriesKey` - the series key (`null` not permitted).
  `rowKey` - the row key (`null` not permitted).
  `columnKey` - the column key (`null` not permitted).
Returns:
  The value (possibly `null`).